com.saxonica.functions.extfn

## Class GeneralFilterFunction

- java.lang.Object
- - net.sf.saxon.lib.ExtensionFunctionDefinition
  - - com.saxonica.functions.extfn.GeneralFilterFunction

- All Implemented Interfaces:
    Serializable
  Direct Known Subclasses:
    Highest, Leading, Lowest, Sort

      public abstract class GeneralFilterFunction
      extends ExtensionFunctionDefinition

  This class provides an abstract framework for a collection of extension functions that have the same general characteristics: (a) the first argument is a sequence, (b) the result is a subset/rearrangement of that sequence, (d) the second argument is a single argument function that is applied to the members of the sequence, (e) the default function if the second argument is omitted is fn:data(), (e) the processing may depend on the default collation.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `GeneralFilterFunction.GeneralFilterFunctionCall`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeneralFilterFunction()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `SequenceType[]` | `getArgumentTypes()` Get the required types for the arguments of this function, counting from zero
    `int` | `getMaximumNumberOfArguments()` Get the maximum number of arguments allowed by the function
    `int` | `getMinimumNumberOfArguments()` Get the minimum number of arguments required by the function
    `SequenceType` | `getResultType(SequenceType[] suppliedArgumentTypes)` Get the type of the result of the function

    - ### Methods inherited from class net.sf.saxon.lib.ExtensionFunctionDefinition

      `dependsOnFocus, getFunctionQName, hasSideEffects, makeCallExpression, trustResultType`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GeneralFilterFunction

          public GeneralFilterFunction()

  - ### Method Detail

    - #### getMinimumNumberOfArguments

          public int getMinimumNumberOfArguments()

      Get the minimum number of arguments required by the function
      Overrides:
        `getMinimumNumberOfArguments` in class `ExtensionFunctionDefinition`
      Returns:
        the minimum number of arguments that must be supplied in a call to this function

    - #### getMaximumNumberOfArguments

          public int getMaximumNumberOfArguments()

      Get the maximum number of arguments allowed by the function
      Overrides:
        `getMaximumNumberOfArguments` in class `ExtensionFunctionDefinition`
      Returns:
        the maximum number of arguments that may be supplied in a call to this function

    - #### getArgumentTypes

          public SequenceType[] getArgumentTypes()

      Get the required types for the arguments of this function, counting from zero
      Specified by:
        `getArgumentTypes` in class `ExtensionFunctionDefinition`
      Returns:
        the required types of the argument, as defined by the function signature. Normally this should be an array of size `getMaximumNumberOfArguments()`; however for functions that allow a variable number of arguments, the array can be smaller than this, with the last entry in the array providing the required type for all the remaining arguments.

    - #### getResultType

          public SequenceType getResultType(SequenceType[] suppliedArgumentTypes)

      Get the type of the result of the function
      Specified by:
        `getResultType` in class `ExtensionFunctionDefinition`
      Parameters:
        `suppliedArgumentTypes` - the static types of the arguments to the function. This is provided so that a more precise result type can be returned in the common case where the type of the result depends on the type of the first argument. The value will be null if the function call has no arguments.
      Returns:
        the return type of the function, as defined by its function signature

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.